main() {
	ambientPlay("ambient_mp_chateau");

	level._effect["fire"] = loadfx ("fx/fire/firesmall.efx");
	level._effect["smoke"] = loadfx("fx/smoke/blacksmokelinger.efx");

	// furnace
	maps\mp\_fx::loopfx("fire", (3408, -3836, 68), 0.2);
	maps\mp\_fx::loopfx("smoke", (3408, -3856, 266), 0.5);

	// fireplace
	maps\mp\_fx::loopfx("fire", (488, -1660, 156), 0.6);

	// Thanks to Coleman for the below routine
	level thread PlaySoundLoopAtLocation( "firesound", (3408,-3856,68) );
	level thread PlaySoundLoopAtLocation( "firesound", (488,-1660,156) );

	// must cast variables as integers for SetCullFog routine
	CurMinFog = (int)4000;
	CurMaxFog = (int)8000;
	setCullFog (CurMinFog, CurMaxFog, 0.20, 0.15, 0.1, 0);					

	// to disable pulsating fog, add comments "//" to the line below
	thread setVariantFog( CurMinFog, CurMaxFog );

	maps\mp\_load::main();

	// comment the line below out if you wish to remove the yelling
	maps\mp\castle2_thread::main();

	game["allies"] = "american";
	game["axis"] = "german";

	game["american_soldiertype"] = "airborne";
	game["american_soldiervariation"] = "normal";
	game["german_soldiertype"] = "wehrmacht";
	game["german_soldiervariation"] = "normal";

	game["layoutimage"] = "castle";


	// SD settings
	game["attackers"] = "allies";
	game["defenders"] = "axis";
	game["SD_OBJ_ATTACKERS"] = "Seek and eliminate all Axis forces!";
	game["SD_OBJ_DEFENDERS"] = "Stay alive and eliminate all Allied forces!";
	game["SD_OBJ_SPECTATOR_ALL"] = "Allies: Find and eliminate all Axis forces.\nAxis: Stay alive and eliminate as many Allied soldiers as possible.";


	// applies only if search & destroy is selected gametype
	if ( ( getCvar("g_gametype") == "sd" ) || ( getCvar("g_gametype") == "SD" ) ) {
		timer = (int)0;
		thread setobjectives(timer);	
	}


	// Thanks to Wyatt for his RE tutorial
	level.obj["codebook"] = (&"RE_OBJ_CODE_BOOK");
	game["re_attackers"] = "allies";
	game["re_defenders"] = "axis";
	game["re_attackers_obj_text"] = "Capture the code book, eliminate any resistance.";
	game["re_defenders_obj_text"] = "Prevent the Allies from capturing the code book.";
	game["re_spectator_obj_text"] = "The Allies must capture the code book.";
	game["re_attackers_intro_text"] = "Capture the code book!";
	game["re_defenders_intro_text"] = "Defend the code book!";

}

setobjectives( timer) {

	players = getentarray("player", "classname");

	for ( i = 0; i < players.size; i++ ) {

		if ( players[i].pers["team"] == game["attackers"])
			players[i] setClientCvar("cg_objectiveText", game["SD_OBJ_ATTACKERS"]);
		else if ( players[i].pers["team"] == game["defenders"])
			players[i] setClientCvar("cg_objectiveText", game["SD_OBJ_DEFENDERS"]);
		else
			players[i] setClientCvar("cg_objectiveText", game["SD_OBJ_SPECTATOR_ALL"]);
	}	

	wait(1);
	newtimer = (int) (timer + 1);	

	if ( timer == 5 ) {
		iprintlnbold("Ignore the bombzones!");
		iprintlnbold("Allies: Eliminate team Axis!");
		iprintlnbold("Axis: Stay alive!");
	}
	if ( timer < 60 ) {
		self thread setobjectives(newtimer);
	}

	return;
}

// plays a looping sound at the specified location

PlaySoundLoopAtLocation( sound, pos ) {
	org = spawn( "script_model", (pos));
	org.origin = pos;
	org playLoopSound( sound);
}


// pulsating fog thread; it will vary the fog distance and create the appearance of an ever-changing fog.
setVariantFog( CurMinFog, CurMaxFog ) {

	newMinFog = (int) (randomInt(40) + 4) * 100;
	newMaxFog = (int) newMinFog + ( (randomInt(40) + 40) * 100);

// debug code
//	iprintlnbold("newMinFog = ", newMinFog);
//	iprintlnbold("newMaxFog = ", newMaxFog);

	while ( ( NewMinFog != CurMinFog ) || ( NewMaxFog != CurMaxFog ) ) {

		if (newMinFog < CurMinFog) {

			CurMinFog = CurMinFog - 10;
		}
		else if (newMinFog > CurMinFog) {

			CurMinFog = CurMinFog + 10;
		}

		if (newMaxFog < CurMaxFog) {

			CurMaxFog = CurMaxFog - 10;
		}
		else if (newMaxFog > CurMaxFog) {

			CurMaxFog = CurMaxFog + 10;
		}
		setCullFog(CurMinFog, CurMaxFog, 0.20, 0.15, 0.10, 0 );
		wait(0.10);
	}
	self thread setVariantFog( CurMinFog, CurMaxFog );
	return;
}


